<?php declare(strict_types=1);

namespace Plugin\css_zubehoer\Migrations;

use JTL\Helpers\Text;
use JTL\Plugin\PluginInterface;
use JTL\Shop;
use JTL\Mail\Mail\Mail;
use JTL\Mail\Mailer;


use JTL\Plugin\Migration;
use JTL\Update\IMigration;


class Migration20210526123301 extends Migration implements IMigration   {
    /**
     * @inheritdoc
     */

    /*
    define('JTLLOG_LEVEL_EMERGENCY', 600);
    define('JTLLOG_LEVEL_ALERT', 550);
    define('JTLLOG_LEVEL_CRITICAL', 500);
    define('JTLLOG_LEVEL_ERROR', 400);
    define('JTLLOG_LEVEL_WARNING', 300);
    define('JTLLOG_LEVEL_NOTICE', 250);
    define('JTLLOG_LEVEL_INFO', 200);
    define('JTLLOG_LEVEL_DEBUG', 100);
*/

    public function JTLWriteLog($cLog='',$nLevel=JTLLOG_LEVEL_INFO ,$bForce=false) {
        if (\mb_strlen($cLog) > 0 && ($bForce || \Jtllog::getSytemlogFlag(false))) {
            $logger = Shop::Container()->getLogService();
            $logger = $logger->withName((string) "css_zubehoerConfig");
            $logger->log($nLevel, $cLog, ["css_zubehoerConfig"]);
            return true;
        }
        return false;
    }

    public function up()    {
        $this->execute("
              CREATE TABLE IF NOT EXISTS `css_zubehoerConfig` (
                  `version`  varchar(10) NOT NULL DEFAULT '2.0.0',
                  `sqlupdate` int(10) NOT NULL DEFAULT '0',
                  `framework` char(3) NOT NULL default 'B4',
                  `pluginActive` char(1) NOT NULL default 'N',
                  `css` text NOT NULL,
                  `js` text NOT NULL,
                  `zubehoerPosition` varchar(40) NOT NULL DEFAULT 'before',
                  `zubehoerSelector` varchar(255) NOT NULL DEFAULT '#add-to-cart',
                  `zubehoerSortierung` varchar(10) NOT NULL DEFAULT 'unten',
                  `zubehoerHideXsell` char(1) NOT NULL DEFAULT 'Y',
                  `zubehoerXsellGroup` int(10) NOT NULL DEFAULT '0',
                  `zubehoerImagesize` varchar(40) NOT NULL DEFAULT 'bilder_artikel_klein_breite',
                  `zubehoerBeschreibung` varchar(19) NOT NULL DEFAULT 'short',
                  `bundleBeschreibung` varchar(19) NOT NULL DEFAULT 'short',
                  `bundlePosition` varchar(40) NOT NULL DEFAULT 'after',
                  `bundleSelector` varchar(255) NOT NULL DEFAULT '#buy_form',
                  `bundleHideXsell` char(1) NOT NULL DEFAULT 'Y',
                  `bundleXsellGroup` int(10) NOT NULL DEFAULT '0',
                  `bundleImagesize` varchar(40) NOT NULL DEFAULT 'bilder_artikel_klein_breite',
                  `bundleSelectItems` char(1) NOT NULL DEFAULT 'Y',
                  `buttonModusZubehoer` varchar(20) NOT NULL DEFAULT 'basket',
                  `buttonModusBundle` varchar(20) NOT NULL DEFAULT 'detail'
                  ) ENGINE=InnoDB COLLATE utf8_unicode_ci
        ");


        $result = $this->getDB()->query(
            'SELECT * from `css_zubehoerConfig` where 1',
            2
        );

        if($result === null || count($result) < 1) {
           $this->execute(
            "INSERT INTO `css_zubehoerConfig` (`version`) VALUES ('2.0.0')"
            );
        } else {
            $this->execute("UPDATE css_zubehoerConfig set `version` = '2.0.0' ");
        }
    }

    /**
     * @inheritdoc
     */
    public function down() {
        if ($this->doDeleteData()) {
            self::JTLWriteLog('drop Tables from css_zubehoer');
        }
    }
}
